//
//	xmasdemo.h - header file for demo bitmap
//
//	ͻ
//	                                                              
//	     Copyright (c) 1993 Digital Video Arts, Ltd.              
//	                    All Rights Reserved                       
//	                                                              
//	ͼ
//

//
//	VRAM constants
//
#define BM1Y 	0x10000L
#define BM1VU	0x60000L
#define BM2Y 	0x20000L
#define BM2VU	0x60040L
#define BM3Y 	0x30000L
#define BM3VU	0x64000L
#define BM4Y 	0x40000L
#define BM4VU	0x64040L
#define BM5Y 	0x50000L
#define BM5VU	0x68000L

#define ONSCRY	0x70000L		// visible 512x480 display
#define ONSCRVU	0xb0000L		
#define MAPY	0xc0000L		// map table
#define BALLSY	0xd0000L		// save area for balls
#define WARPY	0xe0000L		// offscreen warp area
#define TEXTY	0xf0000L		// ofscreen for TEXT data
#define TEXTVU  0x68040L

//	Space for the input buffer, only one needed since always
//	playing only the Y stream

#define YVU_BUFFER	0x100000L
#define YVU_SIZE	0x020000L
//
//	Space for the AUDIO file 
//
#define AUDIOBUFFER	0x120000L
#define AUDIOSIZE	0x060000L
#define USERPOOL	0x180000l	// start of user pool

//
//	filenames
//
#define AUDIOFILE	"xmassong.dat"
#define VIDEOFILE	"yulelog.avs"
#define STILLFILE	"xmastree.i9"
#define XMASFONT	"abbey18.218"
#define LOGOFILE	"dvalogo.i7"
#define MAPFILE		"ballmap.i16"

//
//	Other constants
//
#define XMASGREETING "Season's Greetings"
#define SAMPLE_RATE (unsigned int)(132300L/4L)
#define DEFAULT_FRAME_RATE 30
#define FRAME_SIZE SAMPLE_RATE/DEFAULT_FRAME_RATE

#define WARP0 0
#define WARP1 1
#define WARP2 2
#define MAXWARPS 3			// number of unique texture maps
#define MAXBALLS 8			// number of destination balls

//
//	structures
//
typedef struct {
	Bitmap *spawn;		// spawned bitmap copy
	Point p;		// location on image
	int warpno;		// which warp is it.
	U8 red, green, blue;	// ball color
} BallStruct;

//
//	externs
//
extern DisplayDef *d[6], *warp, *map, *mapg, *text, *onscreen, *balls;
extern AvH *a;				// fire
extern int channel;			// audio channel
extern long audiolength;		// length of audio data
extern Rect warps[MAXWARPS];		// description of unique warps
extern BallStruct Balls[MAXBALLS];	// ball descriptions on screen
//
//	Prototypes
//
NwErr(char *);
void InitAudio(void);
void InitImages(void);
void InitAvss(void);
void InitNewworld(void);
void InitDisplays(void);
void AvGraphics(AvS *,Bitmap *, Bitmap *, long);
int PlayAudio(void);
int PlayVideo(void);
GrCopyMap(Bitmap *, Point *, Bitmap *, Point *, Bitmap *, Rect *, int);
